#!/usr/bin/python

import bz2, os

def _pad_int_str(s,n):
    return "0"*(n-len(str(s))) + str(s)

classno = {}
for DIR in os.listdir('.'):
    if DIR != 'Class' and os.path.isdir(DIR):
        D1 = int(DIR)
        for FILE in os.listdir(DIR):
            if FILE.split('.')[3] == 'dbz':
	        size = os.path.getsize(DIR + '/' + FILE)
                if size == 0:
		    print DIR + '/' + FILE
		else:
		    f = bz2.BZ2File(DIR + '/' + FILE)
		    DAB = FILE.split('.')
		    A1 = int(DAB[1])
		    B1 = int(DAB[2])
		    seq = f.read().split('\n');
		    try:  
		        h = int(seq[0])
      		    except ValueError:
		        raise ValueError, "File %s must be corrupt (data seq = %s)" % (DIR + '/' + FILE , seq)
		    t = int(seq[2])
                    DAB_list = (D1,A1,B1)
		    if t == 2:
		        DAB_r = seq[3].strip().split(" ")
			D2 = int(DAB_r[0])
			A2 = int(DAB_r[1])
		        B2 = int(DAB_r[2])
		        DAB_list += (D2,A2,B2)
                    h_invs = tuple(seq[1].strip().split(" "))
                    DAB_list += h_invs
		    if classno.has_key((h,t)): 
		       classno[(h,t)] += [DAB_list]
		    else:
			classno[(h,t)] = [DAB_list]
        print "Finished reading discriminant %s" % D1
classnumbers = classno.keys()
classnumbers.sort()
for h in classnumbers:
    if (h[0] < 1025):
        hhh = _pad_int_str(str(h[0]),6)
        t = h[1]
	filename = 'Class/class.' + hhh + '.' + str(t) + '.db'
	f = open(filename, 'w')
	for DAB in classno[h]:
            DAB1 = DAB[:3]
            f.write("%s %s %s" % DAB1)
	    if t == 2:
                DAB2 = DAB[3:6]
                f.write(" %s %s %s" % DAB2)
                h_invs = DAB[6:]
            else:
                h_invs = DAB[3:]
            for hi in h_invs:
                f.write(" %s" % hi)
            f.write("\n");
	f.close()
	os.system('bzip2 -c ' + filename + ' > ' + filename + 'z')
	os.system('chmod a+r ' + filename + 'z')
	os.system('rm ' + filename)
