#!/usr/bin/python

import bz2, os

def _pad_int_str(s,n):
    return "0"*(n-len(str(s))) + str(s)

classno = {}
for DIR1 in os.listdir('.'):
    if DIR1 != 'Class' and os.path.isdir(DIR1):
        for DIR2 in os.listdir(DIR1):
            D1 = int(DIR1)
            D2 = int(DIR2)
	    D = D1*D2**2
            DIR = DIR1 + '/' + DIR2;
            for FILE in os.listdir(DIR):
                if FILE.split('.')[4] == 'dbz':
                    size = os.path.getsize(DIR + '/' + FILE)
                    if size == 0:
                        print DIR + '/' + FILE
                    else:
                        f = bz2.BZ2File(DIR + '/' + FILE)
                        DABC = FILE.split('.')
                        A = int(DABC[1])
                        B = int(DABC[2])
                        C = int(DABC[3])
                        seq = f.read().split('\n');
                        try:  
                            h = int(seq[0])
                        except ValueError:
                            raise ValueError, "File %s must be corrupt (data seq = %s)" % (
                                DIR + '/' + FILE , seq)
                        t = int(seq[2])
                        if classno.has_key((h,t)): 
                            classno[(h,t)] += [(D,A,B,C)]
                        else:
                            classno[(h,t)] = [(D,A,B,C)]
classnumbers = classno.keys()
classnumbers.sort()
for h in classnumbers:
    if (h[0] < 1025):
        #print "h = %s: %s"%(h,len(classno[h]))
        hhh = _pad_int_str(str(h[0]),6)
        t = str(h[1])
        filename = 'Class/class.' + hhh + '.' + t + '.db'
        f = open(filename, 'w')
        for DABC in classno[h]:
            f.write("%s %s %s %s\n"%DABC)
        f.close()
        os.system('bzip2 -c ' + filename + ' > ' + filename + 'z')
        os.system('rm ' + filename)
